scala.reflect.api

# Constants

###
Related Doc: package api

#### trait Constants extends AnyRef

EXPERIMENTAL

According to the section 6.24 "Constant Expressions" of the Scala language specification, certain expressions (dubbed constant expressions) can be evaluated by the Scala compiler at compile-time.

scala.reflect.api.Constants#Constant instances represent certain kinds of these expressions (with values stored in the `value` field and its strongly-typed views named `booleanValue`, `intValue` etc.), namely:

1. Literals of primitive value classes (bytes, shorts, ints, longs, floats, doubles, chars, booleans and voids).
2. String literals.
3. References to classes (typically constructed with scala.Predef#classOf).
4. References to enumeration values.

Such constants are used to represent literals in abstract syntax trees (the scala.reflect.api.Trees#Literal node) and literal arguments for Java class file annotations (the scala.reflect.api.Annotations#LiteralArgument class).

##### Example

The `value` field deserves some explanation. Primitive and string values are represented as themselves, whereas references to classes and enums are a bit roundabout.

Class references are represented as instances of scala.reflect.api.Types#Type (because when the Scala compiler processes a class reference, the underlying runtime class might not yet have been compiled). To convert such a reference to a runtime class, one should use the `runtimeClass` method of a mirror such as scala.reflect.api.Mirrors#RuntimeMirror (the simplest way to get such a mirror is using scala.reflect.runtime.package#currentMirror).

Enumeration value references are represented as instances of scala.reflect.api.Symbols#Symbol, which on JVM point to methods that return underlying enum values. To inspect an underlying enumeration or to get runtime value of a reference to an enum, one should use a scala.reflect.api.Mirrors#RuntimeMirror (the simplest way to get such a mirror is again scala.reflect.runtime.package#currentMirror).

    enum JavaSimpleEnumeration { FOO, BAR }

    import java.lang.annotation.*;
    @Retention(RetentionPolicy.RUNTIME)
    @Target({ElementType.TYPE})
    public @interface JavaSimpleAnnotation {
      Class<?> classRef();
      JavaSimpleEnumeration enumRef();
    }

    @JavaSimpleAnnotation(
      classRef = JavaAnnottee.class,
      enumRef = JavaSimpleEnumeration.BAR
    )
    public class JavaAnnottee {}

    import scala.reflect.runtime.universe._
    import scala.reflect.runtime.{currentMirror => cm}

    object Test extends App {
      val jann = typeOf[JavaAnnottee].typeSymbol.annotations(0).javaArgs
      def jarg(name: String) = jann(TermName(name)).asInstanceOf[LiteralArgument].value

      val classRef = jarg("classRef").typeValue
      println(showRaw(classRef))             // TypeRef(ThisType(), JavaAnnottee, List())
      println(cm.runtimeClass(classRef))     // class JavaAnnottee

      val enumRef = jarg("enumRef").symbolValue
      println(enumRef)                       // value BAR

      val siblings = enumRef.owner.info.decls
      val enumValues = siblings.filter(sym => sym.isVal && sym.isPublic)
      println(enumValues)                    // Scope{
                                             //   final val FOO: JavaSimpleEnumeration;
                                             //   final val BAR: JavaSimpleEnumeration
                                             // }

      // doesn't work because of https://issues.scala-lang.org/browse/SI-6459
      // val enumValue = mirror.reflectField(enumRef.asTerm).get
      val enumClass = cm.runtimeClass(enumRef.owner.asClass)
      val enumValue = enumClass.getDeclaredField(enumRef.name.toString).get(null)
      println(enumValue)                     // BAR
    }

Self Type
  Universe
Source
  Constants.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
JavaUniverse, Universe, Universe
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Grouped
2. Alphabetic
3. By inheritance

Inherited

1. Constants
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### abstract type Constant >: Null <: Universe.ConstantApi

   This "virtual" case class represents the reflection interface for literal expressions which can not be further broken down or evaluated, such as "true", "0", "classOf[List]".

   This "virtual" case class represents the reflection interface for literal expressions which can not be further broken down or evaluated, such as "true", "0", "classOf[List]". Such values become parts of the Scala abstract syntax tree representing the program. The constants correspond to section 6.24 "Constant Expressions" of the Scala language specification.

   Such constants are used to represent literals in abstract syntax trees (the scala.reflect.api.Trees#Literal node) and literal arguments for Java class file annotations (the scala.reflect.api.Annotations#LiteralArgument class).

   Constants can be matched against and can be constructed directly, as if they were case classes:

       assert(Constant(true).value == true)
       Constant(true) match {
         case Constant(s: String) =>  println("A string: " + s)
         case Constant(b: Boolean) => println("A boolean value: " + b)
         case Constant(x) =>          println("Something else: " + x)
       }

   `Constant` instances can wrap certain kinds of these expressions:

   1. Literals of primitive value classes (`Byte`, `Short`, `Int`, `Long`, `Float`, `Double`, `Char`, `Boolean` and `Unit`) - represented directly as the corresponding type
   2. String literals - represented as instances of the `String`.
   3. References to classes, typically constructed with scala.Predef#classOf - represented as types.
   4. References to enumeration values - represented as symbols.

   Class references are represented as instances of scala.reflect.api.Types#Type (because when the Scala compiler processes a class reference, the underlying runtime class might not yet have been compiled). To convert such a reference to a runtime class, one should use the `runtimeClass` method of a mirror such as `RuntimeMirror` (the simplest way to get such a mirror is using `scala.reflect.runtime.currentMirror`).

   Enumeration value references are represented as instances of scala.reflect.api.Symbols#Symbol, which on JVM point to methods that return underlying enum values. To inspect an underlying enumeration or to get runtime value of a reference to an enum, one should use a scala.reflect.api.Mirrors#RuntimeMirror (the simplest way to get such a mirror is again scala.reflect.runtime.package#currentMirror).

   Usage example:

       enum JavaSimpleEnumeration { FOO, BAR }

       import java.lang.annotation.*;
       @Retention(RetentionPolicy.RUNTIME)
       @Target({ElementType.TYPE})
       public @interface JavaSimpleAnnotation {
         Class<?> classRef();
         JavaSimpleEnumeration enumRef();
       }

       @JavaSimpleAnnotation(
         classRef = JavaAnnottee.class,
         enumRef = JavaSimpleEnumeration.BAR
       )
       public class JavaAnnottee {}

       import scala.reflect.runtime.universe._
       import scala.reflect.runtime.{currentMirror => cm}

       object Test extends App {
         val jann = typeOf[JavaAnnottee].typeSymbol.annotations(0).javaArgs
         def jarg(name: String) = jann(TermName(name)) match {
           // Constant is always wrapped into a Literal or LiteralArgument tree node
           case LiteralArgument(ct: Constant) => value
           case _ => sys.error("Not a constant")
         }

         val classRef = jarg("classRef").value.asInstanceOf[Type]
                                                // ideally one should match instead of casting
         println(showRaw(classRef))             // TypeRef(ThisType(), JavaAnnottee, List())
         println(cm.runtimeClass(classRef))     // class JavaAnnottee

         val enumRef = jarg("enumRef").value.asInstanceOf[Symbol]
                                                // ideally one should match instead of casting
         println(enumRef)                       // value BAR

         val siblings = enumRef.owner.info.decls
         val enumValues = siblings.filter(sym => sym.isVal && sym.isPublic)
         println(enumValues)                    // Scope{
                                                //   final val FOO: JavaSimpleEnumeration;
                                                //   final val BAR: JavaSimpleEnumeration
                                                // }

         // doesn't work because of https://issues.scala-lang.org/browse/SI-6459
         // val enumValue = mirror.reflectField(enumRef.asTerm).get
         val enumClass = cm.runtimeClass(enumRef.owner.asClass)
         val enumValue = enumClass.getDeclaredField(enumRef.name.toString).get(null)
         println(enumValue)                     // BAR
       }

2. #### abstract class ConstantApi extends AnyRef

   The API of Constant instances.

3. #### abstract class ConstantExtractor extends AnyRef

   An extractor class to create and pattern match with syntax `Constant(value)` where `value` is the Scala value of the constant.

### Abstract Value Members

1. #### abstract val Constant: Universe.ConstantExtractor

   The constructor/extractor for `Constant` instances.

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Constants to any2stringadd[Constants] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Constants, B)

   Implicit information
     This member is added by an implicit conversion from Constants to ArrowAssoc[Constants] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (Constants) ⇒ Boolean, msg: ⇒ Any): Constants

   Implicit information
     This member is added by an implicit conversion from Constants to Ensuring[Constants] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (Constants) ⇒ Boolean): Constants

   Implicit information
     This member is added by an implicit conversion from Constants to Ensuring[Constants] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): Constants

    Implicit information
      This member is added by an implicit conversion from Constants to Ensuring[Constants] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): Constants

    Implicit information
      This member is added by an implicit conversion from Constants to Ensuring[Constants] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Constants to StringFormat[Constants] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

24. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### def →[B](y: B): (Constants, B)

    Implicit information
      This member is added by an implicit conversion from Constants to ArrowAssoc[Constants] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Constants to any2stringadd[Constants]

### Inherited by implicit conversion StringFormat from Constants to StringFormat[Constants]

### Inherited by implicit conversion Ensuring from Constants to Ensuring[Constants]

### Inherited by implicit conversion ArrowAssoc from Constants to ArrowAssoc[Constants]

### Constants

### API

The methods available for each reflection entity, without the implementation. Since the reflection entities are later overridden by runtime reflection and macros, their API counterparts guarantee a minimum set of methods that are implemented.

### Extractors

Extractors provide the machinery necessary to allow pattern matching and construction of reflection entities that is similar to case classes, although the entities are only abstract types that are later overridden.

### Ungrouped